test-lib: introduce 'test_atexit'
[git/git.git] / t / test-lib.sh
CommitLineData
c74c7203 1# Test framework for git. See t/README for usage.
e1970ce4
JH
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
3c8f12c9
JH
18# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
85176d72
FC
26else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
3c8f12c9
JH
30fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
d0cc5796
JK
39# If we were built with ASAN, it may complain about leaks
40# of program-lifetime variables. Disable it by default to lower
41# the noise level. This needs to happen at the start of the script,
42# before we even do our "did we build git yet" check (since we don't
43# want that one to complain to stderr).
bf1ce904 44: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
d0cc5796
JK
45export ASAN_OPTIONS
46
85b81b35
JK
47# If LSAN is in effect we _do_ want leak checking, but we still
48# want to abort so that we notice the problems.
49: ${LSAN_OPTIONS=abort_on_error=1}
50export LSAN_OPTIONS
51
8abfdf44
JS
52if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
53then
54 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
55 exit 1
56fi
57. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58export PERL_PATH SHELL_PATH
59
2006f0ad
RR
60################################################################
61# It appears that people try to run tests without building...
8abfdf44 62"${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
2006f0ad
RR
63if test $? != 1
64then
ed306e4e
JS
65 if test -n "$GIT_TEST_INSTALLED"
66 then
67 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
68 else
69 echo >&2 'error: you do not seem to have built git yet.'
70 fi
2006f0ad
RR
71 exit 1
72fi
73
8cf58006
SG
74# Parse options while taking care to leave $@ intact, so we will still
75# have all the original command line options when executing the test
76# script again for '--tee' and '--verbose-log' below.
77store_arg_to=
78prev_opt=
79for opt
80do
81 if test -n "$store_arg_to"
82 then
83 eval $store_arg_to=\$opt
84 store_arg_to=
85 prev_opt=
86 continue
87 fi
88
89 case "$opt" in
90 -d|--d|--de|--deb|--debu|--debug)
91 debug=t ;;
92 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
93 immediate=t ;;
94 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
95 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
96 -r)
97 store_arg_to=run_list
98 ;;
99 --run=*)
100 run_list=${opt#--*=} ;;
101 -h|--h|--he|--hel|--help)
102 help=t ;;
103 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
104 verbose=t ;;
105 --verbose-only=*)
106 verbose_only=${opt#--*=}
107 ;;
108 -q|--q|--qu|--qui|--quie|--quiet)
109 # Ignore --quiet under a TAP::Harness. Saying how many tests
110 # passed without the ok/not ok details is always an error.
111 test -z "$HARNESS_ACTIVE" && quiet=t ;;
112 --with-dashes)
113 with_dashes=t ;;
dd167a30
JS
114 --no-bin-wrappers)
115 no_bin_wrappers=t ;;
8cf58006
SG
116 --no-color)
117 color= ;;
118 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
119 valgrind=memcheck
120 tee=t
121 ;;
122 --valgrind=*)
123 valgrind=${opt#--*=}
124 tee=t
125 ;;
126 --valgrind-only=*)
127 valgrind_only=${opt#--*=}
128 tee=t
129 ;;
130 --tee)
131 tee=t ;;
132 --root=*)
133 root=${opt#--*=} ;;
134 --chain-lint)
135 GIT_TEST_CHAIN_LINT=1 ;;
136 --no-chain-lint)
137 GIT_TEST_CHAIN_LINT=0 ;;
138 -x)
139 trace=t ;;
140 -V|--verbose-log)
141 verbose_log=t
142 tee=t
143 ;;
22231908
JS
144 --write-junit-xml)
145 write_junit_xml=t
146 ;;
fb7d1e3a
SG
147 --stress)
148 stress=t ;;
149 --stress=*)
150 stress=${opt#--*=}
151 case "$stress" in
7d661e5e 152 *[!0-9]*|0*|"")
fb7d1e3a
SG
153 echo "error: --stress=<N> requires the number of jobs to run" >&2
154 exit 1
155 ;;
156 *) # Good.
157 ;;
158 esac
159 ;;
76e27fbf
SG
160 --stress-limit=*)
161 stress_limit=${opt#--*=}
162 case "$stress_limit" in
7d661e5e 163 *[!0-9]*|0*|"")
76e27fbf
SG
164 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
165 exit 1
166 ;;
167 *) # Good.
168 ;;
169 esac
170 ;;
8cf58006
SG
171 *)
172 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
173 esac
174
175 prev_opt=$opt
176done
177if test -n "$store_arg_to"
178then
179 echo "error: $prev_opt requires an argument" >&2
180 exit 1
181fi
182
183if test -n "$valgrind_only"
184then
185 test -z "$valgrind" && valgrind=memcheck
186 test -z "$verbose" && verbose_only="$valgrind_only"
187elif test -n "$valgrind"
188then
189 test -z "$verbose_log" && verbose=t
190fi
191
fb7d1e3a
SG
192if test -n "$stress"
193then
194 verbose=t
195 trace=t
196 immediate=t
197fi
198
199TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
62c379b8
SG
200TEST_NAME="$(basename "$0" .sh)"
201TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
fb7d1e3a
SG
202TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
203TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
61f292db
SG
204test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
205case "$TRASH_DIRECTORY" in
206/*) ;; # absolute path is good
207 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
208esac
62c379b8 209
fb7d1e3a
SG
210# If --stress was passed, run this test repeatedly in several parallel loops.
211if test "$GIT_TEST_STRESS_STARTED" = "done"
212then
213 : # Don't stress test again.
214elif test -n "$stress"
215then
216 if test "$stress" != t
217 then
218 job_count=$stress
219 elif test -n "$GIT_TEST_STRESS_LOAD"
220 then
221 job_count="$GIT_TEST_STRESS_LOAD"
222 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
223 test -n "$job_count"
224 then
225 job_count=$((2 * $job_count))
226 else
227 job_count=8
228 fi
229
230 mkdir -p "$TEST_RESULTS_DIR"
231 stressfail="$TEST_RESULTS_BASE.stress-failed"
232 rm -f "$stressfail"
233
234 stress_exit=0
235 trap '
236 kill $job_pids 2>/dev/null
237 wait
238 stress_exit=1
239 ' TERM INT HUP
240
241 job_pids=
242 job_nr=0
243 while test $job_nr -lt "$job_count"
244 do
245 (
246 GIT_TEST_STRESS_STARTED=done
247 GIT_TEST_STRESS_JOB_NR=$job_nr
248 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
249
250 trap '
251 kill $test_pid 2>/dev/null
252 wait
253 exit 1
254 ' TERM INT
255
76e27fbf
SG
256 cnt=1
257 while ! test -e "$stressfail" &&
258 { test -z "$stress_limit" ||
259 test $cnt -le $stress_limit ; }
fb7d1e3a
SG
260 do
261 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
262 test_pid=$!
263
264 if wait $test_pid
265 then
266 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
267 else
268 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
269 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
270 fi
271 cnt=$(($cnt + 1))
272 done
273 ) &
274 job_pids="$job_pids $!"
275 job_nr=$(($job_nr + 1))
276 done
277
278 wait
279
280 if test -f "$stressfail"
281 then
76e27fbf 282 stress_exit=1
fb7d1e3a
SG
283 echo "Log(s) of failed test run(s):"
284 for failed_job_nr in $(sort -n "$stressfail")
285 do
286 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
287 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
288 done
289 rm -rf "$TRASH_DIRECTORY.stress-failed"
290 # Move the last one.
291 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
292 fi
293
294 exit $stress_exit
295fi
296
4cde519f
RR
297# if --tee was passed, write the output not only to the terminal, but
298# additionally to the file test-results/$BASENAME.out, too.
8cf58006
SG
299if test "$GIT_TEST_TEE_STARTED" = "done"
300then
301 : # do not redirect again
302elif test -n "$tee"
303then
62c379b8 304 mkdir -p "$TEST_RESULTS_DIR"
452320f1
JK
305
306 # Make this filename available to the sub-process in case it is using
307 # --verbose-log.
62c379b8 308 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
452320f1
JK
309 export GIT_TEST_TEE_OUTPUT_FILE
310
311 # Truncate before calling "tee -a" to get rid of the results
312 # from any previous runs.
313 >"$GIT_TEST_TEE_OUTPUT_FILE"
314
3f824e91 315 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
62c379b8
SG
316 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
317 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
4cde519f 318 exit
8cf58006
SG
319fi
320
321if test -n "$trace" && test -n "$test_untraceable"
322then
323 # '-x' tracing requested, but this test script can't be reliably
324 # traced, unless it is run with a Bash version supporting
325 # BASH_XTRACEFD (introduced in Bash v4.1).
326 #
327 # Perform this version check _after_ the test script was
328 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
329 # '--verbose-log', so the right shell is checked and the
330 # warning is issued only once.
331 if test -n "$BASH_VERSION" && eval '
332 test ${BASH_VERSINFO[0]} -gt 4 || {
333 test ${BASH_VERSINFO[0]} -eq 4 &&
334 test ${BASH_VERSINFO[1]} -ge 1
335 }
336 '
337 then
338 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
339 else
340 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
341 trace=
342 fi
343fi
344if test -n "$trace" && test -z "$verbose_log"
345then
346 verbose=t
347fi
4cde519f 348
e1970ce4 349# For repeatability, reset the environment to known value.
d5c1b7c2 350# TERM is sanitized below, after saving color control sequences.
e1970ce4 351LANG=C
899460f3 352LC_ALL=C
d9bdd39e 353PAGER=cat
e1970ce4 354TZ=UTC
d5c1b7c2 355export LANG LC_ALL PAGER TZ
8ff99e74 356EDITOR=:
6cdccfce
ÆAB
357
358# GIT_TEST_GETTEXT_POISON should not influence git commands executed
359# during initialization of test-lib and the test repo. Back it up,
360# unset and then restore after initialization is finished.
361if test -n "$GIT_TEST_GETTEXT_POISON"
362then
363 GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
364 unset GIT_TEST_GETTEXT_POISON
365fi
366
661bfd13
SL
367# A call to "unset" with no arguments causes at least Solaris 10
368# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
369# deriving from the command substitution clustered with the other
370# ones.
3c8f12c9 371unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 372 my @env = keys %ENV;
730477f1
JL
373 my $ok = join("|", qw(
374 TRACE
375 DEBUG
730477f1
JL
376 TEST
377 .*_TEST
378 PROVE
379 VALGRIND
ac001282 380 UNZIP
edb54081 381 PERF_
e2a0ccc0 382 CURL_VERBOSE
4527aa10 383 TRACE_CURL
730477f1
JL
384 ));
385 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
386 print join("\n", @vars);
387')
7976e901 388unset XDG_CACHE_HOME
5adf84eb 389unset XDG_CONFIG_HOME
8bade1e1 390unset GITPERLLIB
29e55cd5
JH
391GIT_AUTHOR_EMAIL=author@example.com
392GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
393GIT_COMMITTER_EMAIL=committer@example.com
394GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 395GIT_MERGE_VERBOSITY=5
f8246281
JH
396GIT_MERGE_AUTOEDIT=no
397export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
398export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
399export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 400export EDITOR
e1970ce4 401
124647c4
KB
402# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
403GIT_TRACE_BARE=1
404export GIT_TRACE_BARE
405
4cb54d0a 406check_var_migration () {
4231d1ba
JH
407 # the warnings and hints given from this helper depends
408 # on end-user settings, which will disrupt the self-test
409 # done on the test framework itself.
410 case "$GIT_TEST_FRAMEWORK_SELFTEST" in
411 t) return ;;
412 esac
413
4cb54d0a
BP
414 old_name=$1 new_name=$2
415 eval "old_isset=\${${old_name}:+isset}"
416 eval "new_isset=\${${new_name}:+isset}"
4231d1ba 417
4cb54d0a
BP
418 case "$old_isset,$new_isset" in
419 isset,)
420 echo >&2 "warning: $old_name is now $new_name"
421 echo >&2 "hint: set $new_name too during the transition period"
422 eval "$new_name=\$$old_name"
423 ;;
424 isset,isset)
425 # do this later
426 # echo >&2 "warning: $old_name is now $new_name"
427 # echo >&2 "hint: remove $old_name"
428 ;;
429 esac
430}
431
432check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
1f357b04 433check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
5765d97b 434check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
1f357b04
BP
435
436# Use specific version of the index file format
437if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
5d9fc888 438then
1f357b04 439 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
5d9fc888
TG
440 export GIT_INDEX_VERSION
441fi
442
a731fa91
EP
443# Add libc MALLOC and MALLOC_PERTURB test
444# only if we are not executing the test with valgrind
8cf58006 445if test -n "$valgrind" ||
ee1431bf 446 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
447then
448 setup_malloc_check () {
449 : nothing
450 }
451 teardown_malloc_check () {
452 : nothing
453 }
454else
455 setup_malloc_check () {
456 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
457 export MALLOC_CHECK_ MALLOC_PERTURB_
458 }
459 teardown_malloc_check () {
460 unset MALLOC_CHECK_ MALLOC_PERTURB_
461 }
462fi
a731fa91 463
886a3907
JH
464# Protect ourselves from common misconfiguration to export
465# CDPATH into the environment
466unset CDPATH
467
5565f47c 468unset GREP_OPTIONS
ac001282 469unset UNZIP
5565f47c 470
3d5c0cc9 471case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756 4721|2|true)
025232e8 473 GIT_TRACE=4
1c0cc756 474 ;;
6ce4e61f
CC
475esac
476
cd3c095c
JH
477# Convenience
478#
5555a2aa 479# A regexp to match 5, 35 and 40 hexdigits
cd3c095c 480_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
5555a2aa
CB
481_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
482_x40="$_x35$_x05"
cd3c095c 483
3749fde5
JH
484# Zero SHA-1
485_z40=0000000000000000000000000000000000000000
486
bd981d5f 487OID_REGEX="$_x40"
198857bf 488ZERO_OID=$_z40
f9e7d9f8 489EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
378932d3 490EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
f9e7d9f8 491
3f4ab627
JH
492# Line feed
493LF='
494'
495
a42643aa
JK
496# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
497# when case-folding filenames
498u200c=$(printf '\342\200\214')
499
bd981d5f 500export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
342e9ef2 501
e1970ce4
JH
502# Each test should start with something like this, after copyright notices:
503#
504# test_description='Description of this test...
505# This test checks if command xyzzy does the right thing...
506# '
507# . ./test-lib.sh
d5c1b7c2 508test "x$TERM" != "xdumb" && (
ca92a660
RH
509 test -t 1 &&
510 tput bold >/dev/null 2>&1 &&
511 tput setaf 1 >/dev/null 2>&1 &&
512 tput sgr0 >/dev/null 2>&1
513 ) &&
514 color=t
e1970ce4 515
ca92a660
RH
516if test -n "$color"
517then
d5c1b7c2
RH
518 # Save the color control sequences now rather than run tput
519 # each time say_color() is called. This is done for two
520 # reasons:
521 # * TERM will be changed to dumb
522 # * HOME will be changed to a temporary directory and tput
523 # might need to read ~/.terminfo from the original HOME
524 # directory to get the control sequences
525 # Note: This approach assumes the control sequences don't end
526 # in a newline for any terminal of interest (command
527 # substitutions strip trailing newlines). Given that most
528 # (all?) terminals in common use are related to ECMA-48, this
529 # shouldn't be a problem.
530 say_color_error=$(tput bold; tput setaf 1) # bold red
531 say_color_skip=$(tput setaf 4) # blue
532 say_color_warn=$(tput setaf 3) # brown/yellow
533 say_color_pass=$(tput setaf 2) # green
534 say_color_info=$(tput setaf 6) # cyan
535 say_color_reset=$(tput sgr0)
536 say_color_="" # no formatting for normal text
ca92a660 537 say_color () {
d5c1b7c2
RH
538 test -z "$1" && test -n "$quiet" && return
539 eval "say_color_color=\$say_color_$1"
ca92a660 540 shift
d5c1b7c2 541 printf "%s\\n" "$say_color_color$*$say_color_reset"
ca92a660
RH
542 }
543else
544 say_color() {
545 test -z "$1" && test -n "$quiet" && return
546 shift
547 printf "%s\n" "$*"
548 }
549fi
550
d5c1b7c2
RH
551TERM=dumb
552export TERM
553
55db1df0
PH
554error () {
555 say_color error "error: $*"
6e7b5aaf 556 GIT_EXIT_OK=t
55db1df0
PH
557 exit 1
558}
559
165293af
SG
560BUG () {
561 error >&7 "bug in the test script: $*"
562}
563
55db1df0
PH
564say () {
565 say_color info "$*"
566}
567
614fe015
JK
568if test -n "$HARNESS_ACTIVE"
569then
570 if test "$verbose" = t || test -n "$verbose_only"
571 then
572 printf 'Bail out! %s\n' \
573 'verbose mode forbidden under TAP harness; try --verbose-log'
574 exit 1
575 fi
576fi
577
570f3226
MB
578test "${test_description}" != "" ||
579error "Test script did not set test_description."
580
581if test "$help" = "t"
582then
cb1aefda 583 printf '%s\n' "$test_description"
570f3226
MB
584 exit 0
585fi
586
4d9d62fa 587exec 5>&1
781f76b1 588exec 6<&0
4ecae3c8 589exec 7>&2
452320f1
JK
590if test "$verbose_log" = "t"
591then
592 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
593elif test "$verbose" = "t"
e1970ce4
JH
594then
595 exec 4>&2 3>&1
596else
597 exec 4>/dev/null 3>/dev/null
598fi
599
d88785e4
JK
600# Send any "-x" output directly to stderr to avoid polluting tests
601# which capture stderr. We can do this unconditionally since it
602# has no effect if tracing isn't turned on.
603#
604# Note that this sets up the trace fd as soon as we assign the variable, so it
605# must come after the creation of descriptor 4 above. Likewise, we must never
606# unset this, as it has the side effect of closing descriptor 4, which we
607# use to show verbose tests to the user.
608#
609# Note also that we don't need or want to export it. The tracing is local to
610# this shell, and we would not want to influence any shells we exec.
611BASH_XTRACEFD=4
612
e1970ce4
JH
613test_failure=0
614test_count=0
41ac414e
JH
615test_fixed=0
616test_broken=0
2d84e9fb 617test_success=0
e1970ce4 618
d998bd4a
ÆAB
619test_external_has_tap=0
620
faa4bc35 621die () {
6e7b5aaf 622 code=$?
900721e1
JS
623 # This is responsible for running the atexit commands even when a
624 # test script run with '--immediate' fails, or when the user hits
625 # ctrl-C, i.e. when 'test_done' is not invoked at all.
626 test_atexit_handler || code=$?
6e7b5aaf
CB
627 if test -n "$GIT_EXIT_OK"
628 then
629 exit $code
630 else
631 echo >&5 "FATAL: Unexpected exit with code $code"
632 exit 1
633 fi
faa4bc35
CB
634}
635
6e7b5aaf 636GIT_EXIT_OK=
35641310 637trap 'die' EXIT
c5c39f4e
SG
638# Disable '-x' tracing, because with some shells, notably dash, it
639# prevents running the cleanup commands when a test script run with
640# '--verbose-log -x' is interrupted.
641trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
41184273 642
12a29b1a
TR
643# The user-facing functions are loaded from a separate file so that
644# test_perf subshells can have them too
3c8f12c9 645. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 646
886856ab 647# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 648# the test_expect_* functions instead.
886856ab
JH
649
650test_ok_ () {
22231908
JS
651 if test -n "$write_junit_xml"
652 then
653 write_junit_xml_testcase "$*"
654 fi
d5d9de1b 655 test_success=$(($test_success + 1))
633fe50a 656 say_color "" "ok $test_count - $@"
e1970ce4
JH
657}
658
886856ab 659test_failure_ () {
22231908
JS
660 if test -n "$write_junit_xml"
661 then
662 junit_insert="<failure message=\"not ok $test_count -"
663 junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
664 junit_insert="$junit_insert $(xml_attr_encode \
af9912ef
JS
665 "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
666 then
667 test-tool path-utils skip-n-bytes \
668 "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
669 else
670 printf '%s\n' "$@" | sed 1d
671 fi)")"
22231908 672 junit_insert="$junit_insert</failure>"
af9912ef
JS
673 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
674 then
675 junit_insert="$junit_insert<system-err>$(xml_attr_encode \
676 "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
677 fi
22231908
JS
678 write_junit_xml_testcase "$1" " $junit_insert"
679 fi
d5d9de1b 680 test_failure=$(($test_failure + 1))
633fe50a 681 say_color error "not ok $test_count - $1"
bf0dd8a8 682 shift
cb1aefda 683 printf '%s\n' "$*" | sed -e 's/^/# /'
6e7b5aaf 684 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
685}
686
41ac414e 687test_known_broken_ok_ () {
22231908
JS
688 if test -n "$write_junit_xml"
689 then
690 write_junit_xml_testcase "$* (breakage fixed)"
691 fi
41ac414e 692 test_fixed=$(($test_fixed+1))
633fe50a 693 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
694}
695
696test_known_broken_failure_ () {
22231908
JS
697 if test -n "$write_junit_xml"
698 then
699 write_junit_xml_testcase "$* (known breakage)"
700 fi
41ac414e 701 test_broken=$(($test_broken+1))
633fe50a 702 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 703}
886856ab
JH
704
705test_debug () {
8e832ebc 706 test "$debug" = "" || eval "$1"
e1970ce4
JH
707}
708
e6a6ddc9
TR
709match_pattern_list () {
710 arg="$1"
711 shift
712 test -z "$*" && return 1
713 for pattern_
714 do
715 case "$arg" in
716 $pattern_)
717 return 0
718 esac
719 done
720 return 1
721}
722
0445e6f0
IB
723match_test_selector_list () {
724 title="$1"
725 shift
726 arg="$1"
727 shift
728 test -z "$1" && return 0
729
730 # Both commas and whitespace are accepted as separators.
731 OLDIFS=$IFS
732 IFS=' ,'
733 set -- $1
734 IFS=$OLDIFS
735
736 # If the first selector is negative we include by default.
737 include=
738 case "$1" in
739 !*) include=t ;;
740 esac
741
742 for selector
743 do
744 orig_selector=$selector
745
746 positive=t
747 case "$selector" in
748 !*)
749 positive=
750 selector=${selector##?}
751 ;;
752 esac
753
754 test -z "$selector" && continue
755
756 case "$selector" in
757 *-*)
758 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
759 then
760 echo "error: $title: invalid non-numeric in range" \
761 "start: '$orig_selector'" >&2
762 exit 1
763 fi
764 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
765 then
766 echo "error: $title: invalid non-numeric in range" \
767 "end: '$orig_selector'" >&2
768 exit 1
769 fi
770 ;;
771 *)
772 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
773 then
774 echo "error: $title: invalid non-numeric in test" \
775 "selector: '$orig_selector'" >&2
776 exit 1
777 fi
778 esac
779
780 # Short cut for "obvious" cases
781 test -z "$include" && test -z "$positive" && continue
782 test -n "$include" && test -n "$positive" && continue
783
784 case "$selector" in
785 -*)
786 if test $arg -le ${selector#-}
787 then
788 include=$positive
789 fi
790 ;;
791 *-)
792 if test $arg -ge ${selector%-}
793 then
794 include=$positive
795 fi
796 ;;
797 *-*)
798 if test ${selector%%-*} -le $arg \
799 && test $arg -le ${selector#*-}
800 then
801 include=$positive
802 fi
803 ;;
804 *)
805 if test $arg -eq $selector
806 then
807 include=$positive
808 fi
809 ;;
810 esac
811 done
812
813 test -n "$include"
814}
815
ff09af3f
TR
816maybe_teardown_verbose () {
817 test -z "$verbose_only" && return
818 exec 4>/dev/null 3>/dev/null
819 verbose=
820}
821
822last_verbose=t
823maybe_setup_verbose () {
824 test -z "$verbose_only" && return
26a07309 825 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
826 then
827 exec 4>&2 3>&1
828 # Emit a delimiting blank line when going from
829 # non-verbose to verbose. Within verbose mode the
830 # delimiter is printed by test_expect_*. The choice
831 # of the initial $last_verbose is such that before
832 # test 1, we do not print it.
833 test -z "$last_verbose" && echo >&3 ""
834 verbose=t
835 else
836 exec 4>/dev/null 3>/dev/null
837 verbose=
838 fi
839 last_verbose=$verbose
840}
841
5dfc368f
TR
842maybe_teardown_valgrind () {
843 test -z "$GIT_VALGRIND" && return
844 GIT_VALGRIND_ENABLED=
845}
846
847maybe_setup_valgrind () {
848 test -z "$GIT_VALGRIND" && return
26a07309 849 if test -z "$valgrind_only"
5dfc368f
TR
850 then
851 GIT_VALGRIND_ENABLED=t
852 return
853 fi
854 GIT_VALGRIND_ENABLED=
855 if match_pattern_list $test_count $valgrind_only
856 then
857 GIT_VALGRIND_ENABLED=t
858 fi
859}
860
9b5fe78b 861want_trace () {
f5ba2de6
JK
862 test "$trace" = t && {
863 test "$verbose" = t || test "$verbose_log" = t
864 }
9b5fe78b
JK
865}
866
a136f6d8
JK
867# This is a separate function because some tests use
868# "return" to end a test_expect_success block early
869# (and we want to make sure we run any cleanup like
870# "set +x").
871test_eval_inner_ () {
872 # Do not add anything extra (including LF) after '$*'
873 eval "
9b5fe78b 874 want_trace && set -x
a136f6d8
JK
875 $*"
876}
877
a7c58f28 878test_eval_ () {
90c8a1db
JK
879 # If "-x" tracing is in effect, then we want to avoid polluting stderr
880 # with non-test commands. But once in "set -x" mode, we cannot prevent
a136f6d8
JK
881 # the shell from printing the "set +x" to turn it off (nor the saving
882 # of $? before that). But we can make sure that the output goes to
883 # /dev/null.
884 #
90c8a1db
JK
885 # There are a few subtleties here:
886 #
887 # - we have to redirect descriptor 4 in addition to 2, to cover
888 # BASH_XTRACEFD
889 #
890 # - the actual eval has to come before the redirection block (since
891 # it needs to see descriptor 4 to set up its stderr)
892 #
893 # - likewise, any error message we print must be outside the block to
894 # access descriptor 4
895 #
896 # - checking $? has to come immediately after the eval, but it must
897 # be _inside_ the block to avoid polluting the "set -x" output
898 #
899
900 test_eval_inner_ "$@" </dev/null >&3 2>&4
a136f6d8 901 {
a136f6d8 902 test_eval_ret_=$?
9b5fe78b 903 if want_trace
a136f6d8
JK
904 then
905 set +x
a136f6d8 906 fi
90c8a1db
JK
907 } 2>/dev/null 4>&2
908
909 if test "$test_eval_ret_" != 0 && want_trace
910 then
911 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
912 fi
a136f6d8 913 return $test_eval_ret_
a7c58f28
JN
914}
915
4d9d62fa 916test_run_ () {
b6b0afdc 917 test_cleanup=:
b586744a 918 expecting_failure=$2
bb79af9d 919
92b269f5 920 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
2a01ef8c
JK
921 # turn off tracing for this test-eval, as it simply creates
922 # confusing noise in the "-x" output
923 trace_tmp=$trace
924 trace=
bb79af9d
JK
925 # 117 is magic because it is unlikely to match the exit
926 # code of other programs
878f9883
ES
927 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
928 test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
99a64e4b 929 then
165293af 930 BUG "broken &&-chain or run-away HERE-DOC: $1"
bb79af9d 931 fi
2a01ef8c 932 trace=$trace_tmp
bb79af9d
JK
933 fi
934
a57397b0 935 setup_malloc_check
a7c58f28 936 test_eval_ "$1"
b6b0afdc 937 eval_ret=$?
a57397b0 938 teardown_malloc_check
b586744a 939
a136f6d8
JK
940 if test -z "$immediate" || test $eval_ret = 0 ||
941 test -n "$expecting_failure" && test "$test_cleanup" != ":"
b586744a 942 then
1b3185fc 943 setup_malloc_check
a7c58f28 944 test_eval_ "$test_cleanup"
1b3185fc 945 teardown_malloc_check
b586744a 946 fi
1c0cc756
RJ
947 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
948 then
57e1538a
ÆAB
949 echo ""
950 fi
aa0bcf96 951 return "$eval_ret"
4d9d62fa
PR
952}
953
ae75342c 954test_start_ () {
8586f98b 955 test_count=$(($test_count+1))
ff09af3f 956 maybe_setup_verbose
5dfc368f 957 maybe_setup_valgrind
22231908
JS
958 if test -n "$write_junit_xml"
959 then
960 junit_start=$(test-tool date getnanos)
961 fi
ae75342c
TR
962}
963
964test_finish_ () {
965 echo >&3 ""
5dfc368f 966 maybe_teardown_valgrind
ff09af3f 967 maybe_teardown_verbose
af9912ef
JS
968 if test -n "$GIT_TEST_TEE_OFFSET"
969 then
970 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
971 "$GIT_TEST_TEE_OUTPUT_FILE")
972 fi
ae75342c
TR
973}
974
975test_skip () {
04ece593 976 to_skip=
ef2ac68d 977 skipped_reason=
e6a6ddc9
TR
978 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
979 then
980 to_skip=t
ef2ac68d 981 skipped_reason="GIT_SKIP_TESTS"
e6a6ddc9 982 fi
05236a5e
JN
983 if test -z "$to_skip" && test -n "$test_prereq" &&
984 ! test_have_prereq "$test_prereq"
a7bb3940
JS
985 then
986 to_skip=t
ef2ac68d 987
07431fc8 988 of_prereq=
05236a5e 989 if test "$missing_prereq" != "$test_prereq"
07431fc8 990 then
05236a5e 991 of_prereq=" of $test_prereq"
07431fc8 992 fi
ef2ac68d
IB
993 skipped_reason="missing $missing_prereq${of_prereq}"
994 fi
0445e6f0
IB
995 if test -z "$to_skip" && test -n "$run_list" &&
996 ! match_test_selector_list '--run' $test_count "$run_list"
997 then
998 to_skip=t
999 skipped_reason="--run"
1000 fi
07431fc8 1001
ef2ac68d
IB
1002 case "$to_skip" in
1003 t)
22231908
JS
1004 if test -n "$write_junit_xml"
1005 then
1006 message="$(xml_attr_encode "$skipped_reason")"
1007 write_junit_xml_testcase "$1" \
1008 " <skipped message=\"$message\" />"
1009 fi
1010
633fe50a 1011 say_color skip >&3 "skipping test: $@"
ef2ac68d 1012 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
04ece593
JH
1013 : true
1014 ;;
1015 *)
1016 false
1017 ;;
1018 esac
1019}
1020
342e9ef2
TR
1021# stub; perf-lib overrides it
1022test_at_end_hook_ () {
1023 :
1024}
1025
22231908
JS
1026write_junit_xml () {
1027 case "$1" in
1028 --truncate)
1029 >"$junit_xml_path"
1030 junit_have_testcase=
1031 shift
1032 ;;
1033 esac
1034 printf '%s\n' "$@" >>"$junit_xml_path"
1035}
1036
1037xml_attr_encode () {
1038 printf '%s\n' "$@" | test-tool xml-encode
1039}
1040
1041write_junit_xml_testcase () {
1042 junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1043 shift
1044 junit_attrs="$junit_attrs classname=\"$this_test\""
1045 junit_attrs="$junit_attrs time=\"$(test-tool \
1046 date getnanos $junit_start)\""
1047 write_junit_xml "$(printf '%s\n' \
1048 " <testcase $junit_attrs>" "$@" " </testcase>")"
1049 junit_have_testcase=t
1050}
1051
900721e1
JS
1052test_atexit_cleanup=:
1053test_atexit_handler () {
1054 # In a succeeding test script 'test_atexit_handler' is invoked
1055 # twice: first from 'test_done', then from 'die' in the trap on
1056 # EXIT.
1057 # This condition and resetting 'test_atexit_cleanup' below makes
1058 # sure that the registered cleanup commands are run only once.
1059 test : != "$test_atexit_cleanup" || return 0
1060
1061 setup_malloc_check
1062 test_eval_ "$test_atexit_cleanup"
1063 test_atexit_cleanup=:
1064 teardown_malloc_check
1065}
1066
e1970ce4 1067test_done () {
6e7b5aaf 1068 GIT_EXIT_OK=t
2d84e9fb 1069
900721e1
JS
1070 # Run the atexit commands _before_ the trash directory is
1071 # removed, so the commands can access pidfiles and socket files.
1072 test_atexit_handler
1073
22231908
JS
1074 if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1075 then
1076 test -n "$junit_have_testcase" || {
1077 junit_start=$(test-tool date getnanos)
1078 write_junit_xml_testcase "all tests skipped"
1079 }
1080
1081 # adjust the overall time
1082 junit_time=$(test-tool date getnanos $junit_suite_start)
1083 sed "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1084 <"$junit_xml_path" >"$junit_xml_path.new"
1085 mv "$junit_xml_path.new" "$junit_xml_path"
1086
1087 write_junit_xml " </testsuite>" "</testsuites>"
1088 fi
1089
1c0cc756
RJ
1090 if test -z "$HARNESS_ACTIVE"
1091 then
62c379b8 1092 mkdir -p "$TEST_RESULTS_DIR"
8ef1abe5 1093
62c379b8 1094 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
c54e6be7
ML
1095 total $test_count
1096 success $test_success
1097 fixed $test_fixed
1098 broken $test_broken
1099 failed $test_failure
1100
1101 EOF
8ef1abe5 1102 fi
41ac414e
JH
1103
1104 if test "$test_fixed" != 0
1105 then
633fe50a 1106 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
1107 fi
1108 if test "$test_broken" != 0
1109 then
633fe50a 1110 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
1111 fi
1112 if test "$test_broken" != 0 || test "$test_fixed" != 0
1113 then
1114 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1115 msg="remaining $test_remaining test(s)"
11d54b8b 1116 else
b73d9a23 1117 test_remaining=$test_count
11d54b8b 1118 msg="$test_count test(s)"
41ac414e 1119 fi
e1970ce4 1120 case "$test_failure" in
10b94e28 1121 0)
1c0cc756
RJ
1122 if test $test_external_has_tap -eq 0
1123 then
b73d9a23 1124 if test $test_remaining -gt 0
d87bd7c1 1125 then
633fe50a 1126 say_color pass "# passed all $msg"
d87bd7c1 1127 fi
c7018be5
JH
1128
1129 # Maybe print SKIP message
1130 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1131 case "$test_count" in
1132 0)
1133 say "1..$test_count${skip_all:+ $skip_all}"
1134 ;;
1135 *)
1136 test -z "$skip_all" ||
1137 say_color warn "$skip_all"
1138 say "1..$test_count"
1139 ;;
1140 esac
d998bd4a 1141 fi
abc5d372 1142
06478dab 1143 if test -z "$debug"
4d0912a2 1144 then
06478dab 1145 test -d "$TRASH_DIRECTORY" ||
4d0912a2 1146 error "Tests passed but trash directory already removed before test cleanup; aborting"
abc5d372 1147
06478dab 1148 cd "$TRASH_DIRECTORY/.." &&
046e90d1
JS
1149 rm -fr "$TRASH_DIRECTORY" || {
1150 # try again in a bit
1151 sleep 5;
1152 rm -fr "$TRASH_DIRECTORY"
1153 } ||
4d0912a2 1154 error "Tests passed but test cleanup failed; aborting"
4d0912a2 1155 fi
342e9ef2
TR
1156 test_at_end_hook_
1157
e1970ce4
JH
1158 exit 0 ;;
1159
1160 *)
1c0cc756
RJ
1161 if test $test_external_has_tap -eq 0
1162 then
633fe50a
TR
1163 say_color error "# failed $test_failure among $msg"
1164 say "1..$test_count"
d998bd4a 1165 fi
5099b99d 1166
e1970ce4
JH
1167 exit 1 ;;
1168
1169 esac
1170}
1171
e4597aae 1172if test -n "$valgrind"
4e1be63c 1173then
4e1be63c
JS
1174 make_symlink () {
1175 test -h "$2" &&
1176 test "$1" = "$(readlink "$2")" || {
1177 # be super paranoid
1178 if mkdir "$2".lock
1179 then
1180 rm -f "$2" &&
1181 ln -s "$1" "$2" &&
1182 rm -r "$2".lock
1183 else
1184 while test -d "$2".lock
1185 do
1186 say "Waiting for lock on $2."
1187 sleep 1
1188 done
1189 fi
1190 }
1191 }
1192
1193 make_valgrind_symlink () {
36bfb0e5 1194 # handle only executables, unless they are shell libraries that
11d62145 1195 # need to be in the exec-path.
36bfb0e5 1196 test -x "$1" ||
2a59a6ef 1197 test "# " = "$(test_copy_bytes 2 <"$1")" ||
36bfb0e5 1198 return;
4e1be63c
JS
1199
1200 base=$(basename "$1")
28fab7b2
RS
1201 case "$base" in
1202 test-*)
1203 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1204 ;;
1205 *)
1206 symlink_target="$GIT_BUILD_DIR/$base"
1207 ;;
1208 esac
4e1be63c
JS
1209 # do not override scripts
1210 if test -x "$symlink_target" &&
1211 test ! -d "$symlink_target" &&
2a59a6ef 1212 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
4e1be63c
JS
1213 then
1214 symlink_target=../valgrind.sh
1215 fi
efd92ffd
JS
1216 case "$base" in
1217 *.sh|*.perl)
1218 symlink_target=../unprocessed-script
1219 esac
4e1be63c
JS
1220 # create the link, or replace it if it is out of date
1221 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1222 }
1223
26a07309
TR
1224 # override all git executables in TEST_DIRECTORY/..
1225 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1226 mkdir -p "$GIT_VALGRIND"/bin
503e2241 1227 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
26a07309
TR
1228 do
1229 make_valgrind_symlink $file
1230 done
1231 # special-case the mergetools loadables
1232 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1233 OLDIFS=$IFS
1234 IFS=:
1235 for path in $PATH
1236 do
1237 ls "$path"/git-* 2> /dev/null |
1238 while read file
ad0e6233 1239 do
26a07309 1240 make_valgrind_symlink "$file"
ad0e6233 1241 done
26a07309
TR
1242 done
1243 IFS=$OLDIFS
4e1be63c
JS
1244 PATH=$GIT_VALGRIND/bin:$PATH
1245 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1246 export GIT_VALGRIND
952af351
TR
1247 GIT_VALGRIND_MODE="$valgrind"
1248 export GIT_VALGRIND_MODE
5dfc368f 1249 GIT_VALGRIND_ENABLED=t
26a07309 1250 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 1251 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
1252elif test -n "$GIT_TEST_INSTALLED"
1253then
e4597aae
MO
1254 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1255 error "Cannot run git from $GIT_TEST_INSTALLED."
16df35cb 1256 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
e4597aae
MO
1257 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1258else # normal case, use ../bin-wrappers only unless $with_dashes:
dd167a30 1259 if test -n "$no_bin_wrappers"
1c0cc756 1260 then
dd167a30
JS
1261 with_dashes=t
1262 else
1263 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1264 if ! test -x "$git_bin_dir/git"
1c0cc756 1265 then
dd167a30
JS
1266 if test -z "$with_dashes"
1267 then
1268 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1269 fi
1270 with_dashes=t
e4597aae 1271 fi
dd167a30 1272 PATH="$git_bin_dir:$PATH"
e4597aae 1273 fi
6cec5c68 1274 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
1275 if test -n "$with_dashes"
1276 then
ca7312d3 1277 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
e4597aae 1278 fi
4e1be63c 1279fi
6cec5c68 1280GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 1281GIT_CONFIG_NOSYSTEM=1
3c995beb 1282GIT_ATTR_NOSYSTEM=1
8f323c00 1283export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 1284
5e87eae9
JH
1285if test -z "$GIT_TEST_CMP"
1286then
1287 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1288 then
1289 GIT_TEST_CMP="$DIFF -c"
1290 else
1291 GIT_TEST_CMP="$DIFF -u"
1292 fi
1293fi
1294
20d2a30f 1295GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
6fcca938 1296export GITPERLLIB
6cec5c68 1297test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
1298 error "You haven't built things yet, have you?"
1299}
e1970ce4 1300
d609615f 1301if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1c0cc756 1302then
0e496492
NTND
1303 echo >&2 'You need to build test-tool:'
1304 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
56cf9806
EW
1305 exit 1
1306fi
1307
e1970ce4 1308# Test repository
38b074de 1309rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 1310 GIT_EXIT_OK=t
8d14ac94
JH
1311 echo >&5 "FATAL: Cannot prepare test area"
1312 exit 1
1313}
1314
90cff968 1315HOME="$TRASH_DIRECTORY"
0ea47f9d
JH
1316GNUPGHOME="$HOME/gnupg-home-not-used"
1317export HOME GNUPGHOME
90cff968 1318
1c0cc756
RJ
1319if test -z "$TEST_NO_CREATE_REPO"
1320then
38b074de 1321 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 1322else
38b074de 1323 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 1324fi
22231908 1325
1bd9c648
LW
1326# Use -P to resolve symlinks in our working directory so that the cwd
1327# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 1328cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 1329
d5d9de1b
JS
1330this_test=${0##*/}
1331this_test=${this_test%%-*}
e6a6ddc9
TR
1332if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1333then
1334 say_color info >&3 "skipping test $this_test altogether"
1335 skip_all="skip all tests in $this_test"
1336 test_done
1337fi
f17e9fbb 1338
22231908
JS
1339if test -n "$write_junit_xml"
1340then
1341 junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1342 mkdir -p "$junit_xml_dir"
1343 junit_xml_base=${0##*/}
1344 junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1345 junit_attrs="name=\"${junit_xml_base%.sh}\""
1346 junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1347 date +%Y-%m-%dT%H:%M:%S)\""
1348 write_junit_xml --truncate "<testsuites>" " <testsuite $junit_attrs>"
1349 junit_suite_start=$(test-tool date getnanos)
af9912ef
JS
1350 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1351 then
1352 GIT_TEST_TEE_OFFSET=0
1353 fi
22231908
JS
1354fi
1355
11f470ae
JH
1356# Provide an implementation of the 'yes' utility; the upper bound
1357# limit is there to help Windows that cannot stop this loop from
1358# wasting cycles when the downstream stops reading, so do not be
1359# tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1360# limit the output of the yes utility", 2016-02-02)
8648732e
BC
1361yes () {
1362 if test $# = 0
1363 then
1364 y=y
1365 else
1366 y="$*"
1367 fi
1368
6129c930
JS
1369 i=0
1370 while test $i -lt 99
8648732e 1371 do
6129c930
JS
1372 echo "$y"
1373 i=$(($i+1))
8648732e
BC
1374 done
1375}
1376
f17e9fbb 1377# Fix some commands on Windows
d98b2c5f
JS
1378uname_s=$(uname -s)
1379case $uname_s in
f17e9fbb
JS
1380*MINGW*)
1381 # Windows has its own (incompatible) sort and find
1382 sort () {
1383 /usr/bin/sort "$@"
1384 }
1385 find () {
1386 /usr/bin/find "$@"
1387 }
4114156a
JS
1388 # git sees Windows-style pwd
1389 pwd () {
1390 builtin pwd -W
1391 }
ee9fb68c 1392 # no POSIX permissions
6fd1106a 1393 # backslashes in pathspec are converted to '/'
fb9a2bea 1394 # exec does not inherit the PID
a94114ad 1395 test_set_prereq MINGW
5f4e02e5 1396 test_set_prereq NATIVE_CRLF
a31d0665 1397 test_set_prereq SED_STRIPS_CR
97669eed 1398 test_set_prereq GREP_STRIPS_CR
4d715ac0 1399 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
1400 ;;
1401*CYGWIN*)
1402 test_set_prereq POSIXPERM
a31d0665 1403 test_set_prereq EXECKEEPSPID
cfa96496 1404 test_set_prereq CYGWIN
a31d0665 1405 test_set_prereq SED_STRIPS_CR
97669eed 1406 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
1407 ;;
1408*)
1409 test_set_prereq POSIXPERM
6fd1106a 1410 test_set_prereq BSLASHPSPEC
fb9a2bea 1411 test_set_prereq EXECKEEPSPID
f17e9fbb
JS
1412 ;;
1413esac
704a3143 1414
b082687c 1415( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 1416test -z "$NO_PERL" && test_set_prereq PERL
68c7d276 1417test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
d4e1b47a 1418test -z "$NO_PYTHON" && test_set_prereq PYTHON
94da9193 1419test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
ce9a2570
ÆAB
1420test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1421test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
5e9637c6 1422test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 1423
6cdccfce
ÆAB
1424if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
1425then
1426 GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
1427 unset GIT_TEST_GETTEXT_POISON_ORIG
1428fi
1429
bb946bba 1430# Can we rely on git's output in the C locale?
6cdccfce 1431if test -z "$GIT_TEST_GETTEXT_POISON"
30955229 1432then
30955229
JN
1433 test_set_prereq C_LOCALE_OUTPUT
1434fi
bb946bba 1435
4592e608
NTND
1436if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1437then
1438 GIT_TEST_CHECK_CACHE_TREE=true
1439 export GIT_TEST_CHECK_CACHE_TREE
1440fi
1441
20073274
AS
1442test_lazy_prereq PIPE '
1443 # test whether the filesystem supports FIFOs
7b7bea23
RJ
1444 test_have_prereq !MINGW,!CYGWIN &&
1445 rm -f testfifo && mkfifo testfifo
20073274
AS
1446'
1447
04083f27
JH
1448test_lazy_prereq SYMLINKS '
1449 # test whether the filesystem supports symbolic links
1450 ln -s x y && test -h y
1451'
c91cfd19 1452
b018c735
JN
1453test_lazy_prereq FILEMODE '
1454 test "$(git config --bool core.filemode)" = true
1455'
1456
ac39aa61
MG
1457test_lazy_prereq CASE_INSENSITIVE_FS '
1458 echo good >CamelCase &&
1459 echo bad >camelcase &&
1460 test "$(cat CamelCase)" != good
1461'
1462
6ec63305
WC
1463test_lazy_prereq FUNNYNAMES '
1464 test_have_prereq !MINGW &&
1465 touch -- \
1466 "FUNNYNAMES tab embedded" \
1467 "FUNNYNAMES \"quote embedded\"" \
1468 "FUNNYNAMES newline
1469embedded" 2>/dev/null &&
1470 rm -- \
1471 "FUNNYNAMES tab embedded" \
1472 "FUNNYNAMES \"quote embedded\"" \
1473 "FUNNYNAMES newline
1474embedded" 2>/dev/null
1475'
1476
5b0b5dd4
MG
1477test_lazy_prereq UTF8_NFD_TO_NFC '
1478 # check whether FS converts nfd unicode to nfc
1479 auml=$(printf "\303\244")
1480 aumlcdiar=$(printf "\141\314\210")
1481 >"$auml" &&
742ae10e 1482 test -f "$aumlcdiar"
5b0b5dd4
MG
1483'
1484
09feffb6
JK
1485test_lazy_prereq AUTOIDENT '
1486 sane_unset GIT_AUTHOR_NAME &&
1487 sane_unset GIT_AUTHOR_EMAIL &&
1488 git var GIT_AUTHOR_IDENT
1489'
1490
6219bb22
JH
1491test_lazy_prereq EXPENSIVE '
1492 test -n "$GIT_TEST_LONG"
1493'
1494
5b1fe6eb
ÆAB
1495test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1496 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1497'
1498
e1ecd9e3
JH
1499test_lazy_prereq USR_BIN_TIME '
1500 test -x /usr/bin/time
1501'
1502
1767c517
JK
1503test_lazy_prereq NOT_ROOT '
1504 uid=$(id -u) &&
1505 test "$uid" != 0
1506'
1507
63b747ce
JT
1508test_lazy_prereq JGIT '
1509 type jgit
1510'
1511
719c3da2
JH
1512# SANITY is about "can you correctly predict what the filesystem would
1513# do by only looking at the permission bits of the files and
1514# directories?" A typical example of !SANITY is running the test
1515# suite as root, where a test may expect "chmod -r file && cat file"
1516# to fail because file is supposed to be unreadable after a successful
1517# chmod. In an environment (i.e. combination of what filesystem is
1518# being used and who is running the tests) that lacks SANITY, you may
1519# be able to delete or create a file when the containing directory
1520# doesn't have write permissions, or access a file even if the
1521# containing directory doesn't have read or execute permissions.
1522
f400e51c
TB
1523test_lazy_prereq SANITY '
1524 mkdir SANETESTD.1 SANETESTD.2 &&
1525
1526 chmod +w SANETESTD.1 SANETESTD.2 &&
1527 >SANETESTD.1/x 2>SANETESTD.2/x &&
1528 chmod -w SANETESTD.1 &&
719c3da2 1529 chmod -r SANETESTD.1/x &&
f400e51c 1530 chmod -rx SANETESTD.2 ||
165293af 1531 BUG "cannot prepare SANETESTD"
f400e51c 1532
719c3da2 1533 ! test -r SANETESTD.1/x &&
f400e51c
TB
1534 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1535 status=$?
1536
1537 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1538 rm -rf SANETESTD.1 SANETESTD.2 ||
165293af 1539 BUG "cannot clean SANETESTD"
f400e51c
TB
1540 return $status
1541'
f838ce58 1542
d98b2c5f 1543test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
f838ce58
JK
1544GIT_UNZIP=${GIT_UNZIP:-unzip}
1545test_lazy_prereq UNZIP '
1546 "$GIT_UNZIP" -v
1547 test $? -ne 127
1548'
9a308de3
JK
1549
1550run_with_limited_cmdline () {
1551 (ulimit -s 128 && "$@")
1552}
1553
21dac1de
RJ
1554test_lazy_prereq CMDLINE_LIMIT '
1555 test_have_prereq !MINGW,!CYGWIN &&
1556 run_with_limited_cmdline true
1557'
6b9c38e1 1558
4db464f8
MG
1559run_with_limited_stack () {
1560 (ulimit -s 128 && "$@")
1561}
1562
21dac1de
RJ
1563test_lazy_prereq ULIMIT_STACK_SIZE '
1564 test_have_prereq !MINGW,!CYGWIN &&
1565 run_with_limited_stack true
1566'
4db464f8 1567
6b9c38e1
JK
1568build_option () {
1569 git version --build-options |
1570 sed -ne "s/^$1: //p"
1571}
1572
1573test_lazy_prereq LONG_IS_64BIT '
1574 test 8 -le "$(build_option sizeof-long)"
1575'
a07fb050 1576
a801a7cf
NTND
1577test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1578test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
e9184b07
JK
1579
1580test_lazy_prereq CURL '
1581 curl --version
1582'
d16ab634 1583
1584# SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1585# which will not work with other hash algorithms and tests that work but don't
1586# test anything meaningful (e.g. special values which cause short collisions).
1587test_lazy_prereq SHA1 '
1588 test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1589'
11aad464
JS
1590
1591test_lazy_prereq REBASE_P '
1592 test -z "$GIT_TEST_SKIP_REBASE_P"
1593'